<?php
/*
Plugin Name: DraugiemSay
Plugin URI: http://webtech.lv/projects/draugiemsay/
Description: Draugiem.lv Say notifier
Author: Ingus Rukis
Version: 0.2.2
Author URI: http://webtech.lv
*/ 
add_action('admin_menu', 'draugiemsay_add_pages');
add_action('publish_post', 'draugiemsay_notify');

if (is_admin()){
	function draugiemsay_extendeditor(){
		add_meta_box('draugiemsay_yey', __('Draugiem.lv say Options', 'draugiemsay_trans_domain'), 'draugiemsay_editorblock', 'post', 'side', 'high');
	}
	add_action('admin_menu', 'draugiemsay_extendeditor');
}

function draugiemsay_editorblock(){
	_e('post to DraugiemSay', 'draugiemsay_trans_domain');
	echo '<br /><input type="radio" name="draugiemsay_post" value="1" /> yes<br />
	<input type="radio" name="draugiemsay_post" value="0" /> no';
}


function dr_shorten_link( $thispostlink, $thisposttitle, $cligsapi ) {
	$shrink = @file_get_contents("http://cli.gs/api/v1/cligs/create?appid=draugiemSayWP&url=".$thispostlink."&title=".$thisposttitle."&key=".$cligsapi);
	if ( strpos( $shrink, "http://" ) === FALSE ) {
		$shrink = FALSE;
	}
	return $shrink;
}

function draugiemsay_notify($postid){
	$apikey = get_option('draugiemsay_apikey');
	$cligsapi = get_option( 'cligsapi' );
	if (!empty($apikey) && !empty($_POST['draugiemsay_post'])){
		$p = get_post($postid);
		$text = $p -> post_title;
		$link = get_permalink($postid);
		$leftchars = 137-mb_strlen($link);
		$prefix = get_option('draugiemsay_pretext');
		
		if(isset($cligsapi) && !empty($cligsapi)) {
			$link=dr_shorten_link( $link, $text, $cligsapi );
		}
		
		$profile = get_option('draugiemsay_profile');
		if (!empty($profile)){
			list($type, $uid) = explode("-", $profile);
		}
		
		$xmllink = 'http://api.draugiem.lv/xml/index.php?app=ea0ca99e9e2f046c32524f1979be0b73&apikey=' . $apikey . '&action=say/post&title=' . urlencode($text) . '&link=' . urlencode($link) . '&prefix=' . urlencode($prefix) . '&public=1' . (!empty($profile) ? '&uid=' . $uid . '&type=' . $type : '');
		$xml = file_get_contents($xmllink);
		$xmldata = simplexml_load_string($xml);
	}
}


function draugiemsay_add_pages() {
    // Add a new submenu under Options:
    add_options_page('DraugiemSay Options', 'DraugiemSay Options', 8, 'draugiemsayoptions', 'draugiemsay_options_page');
}

function draugiemsay_options_page() {

	if (!empty($_POST['draugiemsay_authcode'])){
		$xmllink = 'http://api.draugiem.lv/xml/?app=ea0ca99e9e2f046c32524f1979be0b73&code=' . get_option('draugiemsay_authcode') . '&action=authorize';
		$xml = file_get_contents($xmllink);
		$xmldata = simplexml_load_string($xml);
		if (!empty($xmldata -> apikey)){
			update_option('draugiemsay_apikey', (string)$xmldata -> apikey);
			?><div class="updated"><p><strong><?php _e('API key received, you can start using plugin now!', 'draugiemsay_trans_domain' ); ?></strong></p></div><?php
		}else{
			?><div class="updated"><p><strong><?php _e('Error saving options, invalid authcode or Draugiem API out of service', 'draugiemsay_trans_domain' ); ?></strong></p></div><?php
		}
		
	}
	
	if (isset($_POST['draugiemsay_pretext'])){
		update_option('draugiemsay_pretext', $_POST['draugiemsay_pretext']);
	}
	
	if (isset($_POST['draugiemsay_profile'])){
		update_option('draugiemsay_profile', $_POST['draugiemsay_profile']);
	}
	
	if( $_POST[ 'draugiemsay_hidden' ] == 'Y' ) {
		$email = $_POST[ 'draugiemsay_email' ];
		update_option('draugiemsay_authcode', '');
		update_option( 'draugiemsay_email', $email );
		$xmllink = 'http://api.draugiem.lv/xml/?app=ea0ca99e9e2f046c32524f1979be0b73&email=' . $email . '&action=authorize';
		$xml = file_get_contents($xmllink);
		$xmldata = simplexml_load_string($xml);
		if (!empty($xmldata -> authcode)){
			$authcode = (string)$xmldata -> authcode;
			if (strlen($authcode) == 20){
				update_option( 'draugiemsay_authcode', $authcode );
				?><div class="updated"><p><strong><?php _e('Options saved, AuthCode received, please confirm the application in your draugiem settings page!', 'draugiemsay_trans_domain' ); ?></strong></p></div><?php
			}else{
				?><div class="updated"><p><strong><?php _e('Error saving options, invalid e-mail or Draugiem API out of service', 'draugiemsay_trans_domain' ); ?></strong></p></div><?php
			}
		}else{
			?><div class="updated"><p><strong><?php _e('Error saving options, invalid e-mail or Draugiem API out of service', 'draugiemsay_trans_domain' ); ?></strong></p></div><?php
		}
	}
	
	if ( isset($_POST['submit-type']) && $_POST['submit-type'] == 'cligsapi' ) {
		if ( $_POST['cligsapi'] != '' && isset( $_POST['submit'] ) ) {
			update_option( 'cligsapi',$_POST['cligsapi'] );
			$message = __("Cligs API Key Updated");
		} else if ( isset( $_POST['clear'] ) ) {
			update_option( 'cligsapi','' );
			$message = __("Cli.gs API Key deleted. Cli.gs created by WP to Twitter will no longer be associated with your account. ");
		} else {
			$message = __("Cli.gs API Key not added - <a href='http://cli.gs/user/api/'>get one here</a>! ");
		}
	}
	
	// Now display the options editing screen
	echo '<div class="wrap">';
	echo "<h2>" . __( 'DraugiemSay Plugin Options', 'draugiemsay_trans_domain' ) . "</h2>";

// options form

	if ($apikey = get_option('draugiemsay_apikey')){
		?><p style="background-color: #22DD22; color: #fff;">The plugin is fully functional. In case you wish to change settings, please use the form below</p><hr /><?php
	}
    
    if ($message) { ?>
		<div id="message" class="updated fade"><p><?php echo $message; ?></p></div>
	<?php } ?>
	<h2><?php _e("Your draugiem.lv e-mail"); ?></h2>
	<form name="form1" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
	<input type="hidden" name="draugiemsay_hidden" value="Y">
	<p><?php _e("E-mail:", 'draugiemsay_trans_domain' ); ?>
	<input type="text" name="draugiemsay_email" value="<?php echo get_option('draugiemsay_email') ?>" size="20">&nbsp;<input type="submit" name="Submit" value="<?php _e('Update Options', 'draugiemsay_trans_domain' ) ?>" />
	</p>
	</form>
	<?php

	if ($authcode = get_option('draugiemsay_authcode') && empty($apikey)){
		?><hr /><form method="post" action="<?php echo str_replace('%7E', '~', $_SERVER['REQUEST_URI']); ?>">
		<p><?= _e('You can get the API key only after you have confirmed this plugin as allowed application in your draugiem.lv profile', 'draugiemsay_trans_domain'); ?></p>
		<input type="hidden" name="draugiemsay_authcode" value="<?= $authcode; ?>" />
		<p><input type="submit" name="Submit" value="<?php _e('Get the APIKEY', 'draugiemsay_trans_domain' ) ?>" /></p>
		</form><?php
	}


	$text = htmlspecialchars(get_option('draugiemsay_pretext'));
	if (empty($text)){
		$text = __('Blog post:  ', 'draugiemsay_trans_domain');
	}
	?>
	<hr />
		<h2><?php _e("Your DraugiemSay options"); ?></h2>
	<form method="post" action="<?php echo str_replace('%7E', '~', $_SERVER['REQUEST_URI']); ?>">
		<h3><?php _e("DraugiemSay pre text", 'draugiemsay_trans_domain' ); ?></h3>
		<input type="text" name="draugiemsay_pretext" value="<?= $text; ?>" /><?php _e('PreText will be displayed as follows "<strong style="color: #f60">' .  $text . '</strong>: post_title <a href="#">http://post.perma.link/</a>"', 'draugiemsay_trans_domain') ?>
		</p>
		<h3><?php _e("Draugiem.lv profile") ?></h3>
		<p><?php _e("Choose your draugiem.lv profile, which you will use to post the notifications. If none is chosen, notifications will be posted with your default profile", 'draugiemsay_trans_domain' ); ?></p>
		<select name="draugiemsay_profile">
		<?php
		
		$apikey = get_option('draugiemsay_apikey');
		$xml = file_get_contents('http://api.draugiem.lv/xml/?app=ea0ca99e9e2f046c32524f1979be0b73&apikey=' . $apikey . '&action=say/profiles');
		$xml = simplexml_load_string($xml);
		$arr = array();
		if (!empty($xml -> error) && (string)$xml -> error == 'Invalid user API key'){
			update_option('draugiemsay_apikey', '');
		}
		
		$selected = get_option('draugiemsay_profile');
		echo '<option value="">' . __('Default profile', 'draugiemsay_trans_domain') . '</option>';
		foreach ($xml -> profiles -> profile as $profile){
			echo '<option value="'. (string)$profile -> type . '-' . (string)$profile ->  uid . '" '. ($selected ==  (string)$profile -> type . '-' . (string)$profile ->  uid ? ' selected="selected"' : '') . '>' . (string)$profile -> name . '</option>';
			
		}

		?>
		</select>
		<input type="submit" name="Submit" value="<?php _e('ok', 'draugiemsay_trans_domain' ) ?>" />
	</form>
		
	<h2><?php _e("Your Cli.gs account details"); ?></h2>
	<form method="post" action="">
		<div>
			<p>
			<label for="cligsapi"><?php _e("Your Cli.gs <abbr title='application programming interface'>API</abbr> Key:"); ?></label>
			<input type="text" name="cligsapi" id="cligsapi" size="40" value="<?php echo(get_option('cligsapi')) ?>" />
			</p>
			<div>
			<input type="hidden" name="submit-type" value="cligsapi" />
			</div>
			<p><input type="submit" name="submit" value="Save Cli.gs API Key" class="button-primary" /> <input type="submit" name="clear" value="Clear Cli.gs API Key" /><br /><small><?php _e("&raquo; Don't have a Cli.gs account or Cligs API key? <a href='http://cli.gs/user/api/'>Get one free here</a>!<br />&raquo; You'll need an API key in order to associate the Cligs you create with your Cligs account."); ?></small></p>
		</div>
	</form>
	</div><?php
	
	
 
}
